﻿@inject IUserRepository _userRepository

<button type="button" class="btn btn-dark rounded-pill w-100 mt-1" style="color: @UserColor"
        disabled="@DisabledStatus"
        @onmouseover="@(() => OnHover.InvokeAsync((UserNickname, UserColor)))"
        @onmouseout="@(() => OnOut.InvokeAsync())"
        @onclick="@(() => OnClick.InvokeAsync((UserNickname, UserColor)))">
    <span class="font-weight-bold">@UserNickname</span>
</button>

@code {
    private IUserRepository userRepository = null;
    private const string DefaultUserColor = @"#DDDDDD";
    private string UserColor = DefaultUserColor;

    [Parameter]
    public string UserNickname { get; set; }

    [Parameter]
    public EventCallback<(string, string)> OnHover { get; set; }

    [Parameter]
    public EventCallback OnOut { get; set; }

    [Parameter]
    public EventCallback<(string, string)> OnClick { get; set; }

    [Parameter]
    public bool DisabledStatus { get; set; }


    protected override void OnInitialized()
    {
        userRepository = _userRepository;
        try
        {
            UserColor = userRepository.GetUserColor(UserNickname);
        }
        catch (ApplicationException)
        {
            UserColor = DefaultUserColor;
            // throw;
        }
    }

    protected override void OnParametersSet()
    {
        try
        {
            UserColor = userRepository.GetUserColor(UserNickname);
        }
        catch (ApplicationException)
        {
            UserColor = DefaultUserColor;
            // throw;
        }
    }

    //private const string NoUserSelectedLabel = "User";
    //private string candidateUser = NoUserSelectedLabel;
}
